/*
MiniShare - Minimal HTTP Server
Copyright (C) 2002-2004  Tero Lindeman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "minishare.h"
#include "globals.h"
#include "ipdiag.h"
#include "files.h"
#include "misc.h"
#include "server.h"
#include "serve2.h"
#include "ban.h"
#include "error.h"
#include "template.h"

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <process.h>
#include <ctype.h>
#include <time.h>
#include <winsock2.h>
#include <io.h>
#include <fcntl.h>
#include <mswsock.h>


int old_engine=0;

int con_id;


int messagebox_log(HWND h,char *msg1,char *msg2,int t);


SOCKET sock;
connection cons[256];

__int64 update_total_transfer_speed()
{
	__int64 total_transfer_speed=0;
	for (int i=0;i<256;i++)
		if (cons[i].inuse)
		{
			for (int b=0;b<TRANSFER_SPEED_BUFFER_SIZE-1;b++) 
				total_transfer_speed+=cons[i].bytesdownloaded_sec[b];
		}	
	return total_transfer_speed*4/(TRANSFER_SPEED_BUFFER_SIZE-1);
}


int sendmsg(SOCKET s,char *msg,connection *c) {
		int sent=send(s,msg,strlen(msg),0);
		c->bytesdownloaded+=sent;
        return sent;
}


void sendpage(SOCKET s, connection *c,http_request *request,char *filename) {
	char tmp[2048];
    addtolog(c->con_id,"200 OK");
      
    PREPROCESSOR *preprocessor=open_preprocessor(filename);
        
	if (preprocessor!=NULL)
    {
	    sprintf(tmp,"HTTP/1.1 200 OK\r\nContent-Type: %s\r\n\r\n",(c->file==-1)?"text/html":sharedfiles[c->file].mime);
		sendmsg(s, tmp, c);

	    preprocessor->request=request;
		preprocessor->statuscode=200;
        char temp_line[513];
        int r;
        do {
        	r=template_getline(temp_line,512,preprocessor);
        	sendmsg(s,temp_line,c);
    	} while (r);
        	
        close_preprocessor(preprocessor);
    } 
    else 
    {
	    sprintf(tmp,"Error opening template file '%s'",filename);
	 	addtolog(c->con_id,tmp);
   		send_error(s,c,500); 
	}
}

void sendlist(SOCKET s, connection *c,http_request *request) {
	char temp_path[MAX_PATH];
	c->file=-1;
	sendpage(s,c,request,make_workpath_file("layout\\index.tmpl",temp_path));
}

#define MAX_HOSTNAME_SIZE 260

void getownip(char *cip) {
	    char HostName[MAX_HOSTNAME_SIZE];
        PHOSTENT pHostEnt;
        IN_ADDR  *ip;

        if (gethostname(HostName, MAX_HOSTNAME_SIZE)==SOCKET_ERROR) {

                return;
        }
        cip[0]='\0';
        ips=0;
        pHostEnt = gethostbyname(HostName);
        while((ip=(struct in_addr *)*pHostEnt->h_addr_list)!=NULL)

                 {

                       strcpy(cipt[ips],inet_ntoa(*ip));
                       ips++;
                       *pHostEnt->h_addr_list++;
                }
         selip=0;
         if ((ips>1)) {
	     	if (listen_interface[0]=='\0')
	        {
				DialogBox(hInstance,MAKEINTRESOURCE(IP_BOX),0,(DLGPROC) MakeProcInstance((FARPROC)ipproc,hInstance));
				if (selip<0) selip=0;
				strcpy(cip,cipt[selip]);
			}
			else
			{
				strcpy(cip,listen_interface);
			}
			
			
         } else {
         	strcpy(cip,cipt[0]);
     	}
         
         
         if (cip[0]=='\0') {
	         messagebox_log(NULL,"Could not get IP.","Warning",MB_OK);
         }
    
}


void block_socket(SOCKET *s, u_long state)
{
	u_long cmd_option = state;
    ioctlsocket(*s, FIONBIO, &cmd_option);	
}

void _cdecl serverthread(void* ptr) {
        server_running=1;
        addtolog(0,"Server started ("VERSION").");
        //if (old_engine) addtolog(0,"Using old engine.");
        con_id=0;

        while(1) {
	        			     			
                        SOCKET active_sock;
                        SOCKADDR_IN from;
                        int fromlen = sizeof(from);
						
                        active_sock = accept(sock,(SOCKADDR*)&from,&fromlen);
                        if (active_sock==INVALID_SOCKET) {
                           break;
                        }
                        
                        
                        
                        char tmp[128],addy[513];
                        HOSTENT *host;
                        host=gethostbyaddr((char*)&from.sin_addr,4,PF_INET);
                        if (host!=NULL) {
                            sprintf(tmp,"Connect from %s (%s)",host->h_name,inet_ntoa(from.sin_addr));
                            strcpy(addy,host->h_name);
                            }
                        else {
                        	sprintf(tmp,"Connect from %s",inet_ntoa(from.sin_addr));
                        	strcpy(addy,inet_ntoa(from.sin_addr));
                        }

                        con_id++;
                        addtolog(con_id,tmp);
                        connections++;




                            if (connections<=max_connections) {
                                	int i=0;
                                	while((i<256)&&(cons[i].inuse==true)) i++;
                                	if (i==256) goto error_hack;
                                	cons[i].inuse=true;
                                	cons[i].socket=active_sock;
                                	strcpy(cons[i].addr,addy);
                                	strcpy(cons[i].addr_ip,inet_ntoa(from.sin_addr));
                                	cons[i].file=-1;
                                	cons[i].request[0]='\0';
                                	cons[i].sessionstart=time(NULL);
                                	cons[i].last_touch=cons[i].sessionstart;
                                    cons[i].bytesdownloaded=0;
                                    cons[i].bytesdownloaded_file=0;
									ZeroMemory(cons[i].bytesdownloaded_sec,sizeof(__int64)*TRANSFER_SPEED_BUFFER_SIZE);
									cons[i].filesize=-1;
									cons[i].listpos=-1;
                                    cons[i].con_id=con_id;
                                    
                                    
                                    
                        			if (check_banned(cons[i].addr_ip)||check_banned(cons[i].addr)
                        				||(strlen(stunnel_accept_host)>0 && (stricmp(stunnel_accept_host,cons[i].addr)!=0
                        				&& stricmp(stunnel_accept_host,cons[i].addr_ip)!=0))
                        				)
                        			{
                        				send_error(active_sock,cons+i,403);
                        				connections--;
                                    	shutdown(active_sock,SD_BOTH);
                                    	closesocket(active_sock);
                                    	cons[i].inuse=false;
                        			} else {

                                		/*if (old_engine) _beginthread(serve,0,(void*)&(cons[i]));
                                		else*/ _beginthread(serve2,0,(void*)&(cons[i]));
                                		Sleep(50);
                            		}

                            }  else {
	                            			
                                    send_error(active_sock,&(cons[con_id]),503);
                                    error_hack:
                                    connections--;
                                    shutdown(active_sock,SD_BOTH);
                                    closesocket(active_sock);

                                    }



        }
        addtolog(0,"Server stopped.\n");
        server_running=0;
}

void init_server()
{
	WSADATA wsadata;
    WSAStartup(0x101,&wsadata);
}

void start_server()
{
	char temp_path[MAX_PATH];
	   	load_bans(make_workpath_file("banned.txt",temp_path));
	   	u_long ip;
	   	
	   	getownip(server_domain);
	   	
	   	if (listen_interface[0]!='\0') 
	   	{
		   	ip=inet_addr(listen_interface);
		   	if (ip==INADDR_NONE) ip=INADDR_ANY;
	   	} else {
		   	ip=INADDR_ANY;
	   	}
	   	
	   	SOCKADDR_IN local;
		sock=socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);

        memset(&local, 0, sizeof(local));
        local.sin_family = AF_INET;
        local.sin_addr.S_un.S_addr = ip;
        local.sin_port = htons( server_port );

        if (bind(sock,(SOCKADDR*) &local,sizeof(local))==SOCKET_ERROR) {
        	messagebox_log(NULL,Rstr(TEXT_CANTBIND),Rstr(TEXT_ERROR),0);
        } else {
        	listen(sock,256);
        	int *ptr=NULL;
        	_beginthread(serverthread,0,(void*)ptr);
		}
		
		char temp[1024];
		
		if (fixed_domain[0]!='\0')
		{
			strcpy(server_domain,fixed_domain);
		}
		
	   	if (server_port==80) 
	   		sprintf(temp,version_string" - %s",server_domain);
        else 
        	sprintf(temp,version_string" - %s:%d",server_domain,server_port);
        	
        SendMessage(hWnd,WM_SETTEXT,0,(LPARAM)temp);

}

void stop_server()
{
	while (server_running!=0) closesocket(sock);
	int i;
	for(i=0;i<connections;i++) closesocket(cons[i].socket);
}

void deinit_server()
{
	WSACleanup();
}

int kick_user(int id) {
	addtolog(cons[id].con_id,"Kicked user.");
	closesocket(cons[id].socket);
	return 1;
}
