#define TEMPLATEBUFFERSIZE 512
#define INJECTBUFFERSIZE 1024
#define CONDBUFSIZE 32
#define MAX_TOKENLEN TEMPLATEBUFFERSIZE

#include "serve2.h"

typedef struct {
	FILE *source;
	char buffer[TEMPLATEBUFFERSIZE+1],inject_buffer[INJECTBUFFERSIZE+1];
	char token[MAX_TOKENLEN+1];
	int buffer_position,inject_position,token_position;
	int in_token;
	int state;
	int loop_position;
	int current_file,file_id;
	int last_read_position;
	int statuscode;
	int cond_buf[CONDBUFSIZE+1],cond_i;
	http_request *request;
} PREPROCESSOR;

#define TOKEN_ID_VERSION 1
#define TOKEN_ID_BEGINFILES 2
#define TOKEN_ID_FILE_FILENAME 3
#define TOKEN_ID_ENDFILES 4
#define TOKEN_ID_SERVERNAME 5
#define TOKEN_ID_ADDRESS 6
#define TOKEN_ID_PORT 7
#define TOKEN_ID_MINISHARE_URL 8
#define TOKEN_ID_FILE_FILESIZE 9
#define TOKEN_ID_FILE_FILEPATH 10
#define TOKEN_ID_FILE_URL 11
#define TOKEN_ID_FILE_FILEDATE 12
#define TOKEN_ID_SHARED_FILES 13
#define TOKEN_ID_TOTAL_SIZE 14
#define TOKEN_ID_FILE_FILEEXTENSION 15
#define TOKEN_ID_FILE_FILEMIME 16
#define TOKEN_ID_MAXCONNECTIONS 17
#define TOKEN_ID_CONNECTIONS 18
#define TOKEN_ID_CURRENTLOGIN 19
#define TOKEN_ID_CURRENTPASSWD 20
#define TOKEN_ID_CURRENTPATH 21
#define TOKEN_ID_ERRORCODE 22
#define TOKEN_ID_ERRORTEXT 23
#define TOKEN_ID_FILE_FILEID 24
#define TOKEN_ID_COND_IF 25
#define TOKEN_ID_COND_ELSE 26
#define TOKEN_ID_COND_ELSEIF 27
#define TOKEN_ID_COND_ENDIF 28
#define TOKEN_ID_REQUESTSTRING 29

int template_getline(char *output,int maxlen,PREPROCESSOR *p);
void close_preprocessor(PREPROCESSOR *p);
PREPROCESSOR * open_preprocessor(char *filename);



